src/netbox_cert_plugin/urls.py
"""URL definitions"""

from django.urls import path
from netbox.views.generic import ObjectChangeLogView, ObjectJournalView
from netbox_cert_plugin import views, models


urlpatterns = (
    # Cert
    path("certificates/", views.CertificateListView.as_view(), name="certificate_list"),
    path(
        "certificates/add/", views.CertificateAddView.as_view(), name="certificate_add"
    ),
    path(
        "certificates/edit/", views.CertificateEditView.as_view(), name="certificate_edit"
    ),
    path(
        "certificates/import/",
        views.CertificateBulkImportView.as_view(),
        name="certificate_import",
    ),
    path(
        "certificates/delete/",
        views.CertificateBulkDeleteView.as_view(),
        name="certificate_bulk_delete",
    ),
    path("certificates/<int:pk>/", views.CertificateView.as_view(), name="certificate"),
    path(
        "certificates/<int:pk>/edit/",
        views.CertificateEditView.as_view(),
        name="certificate_edit",
    ),
    path(
        "certificates/<int:pk>/delete/",
        views.CertificateDeleteView.as_view(),
        name="certificate_delete",
    ),
    path(
        "certificates/<int:pk>/changelog/",
        ObjectChangeLogView.as_view(),
        name="certificate_changelog",
        kwargs={"model": models.Certificate},
    ),
    path(
        "certificates/<int:pk>/journal/",
        ObjectJournalView.as_view(),
        name="certificate_journal",
        kwargs={"model": models.Certificate},
    ),

    path("CertificateAuthority/", views.CertificateAuthorityListView.as_view(), name="certificateauthority_list"),
    path("CertificateAuthority/add/", views.CertificateAuthorityEditView.as_view(), name="certificateauthority_add"),
    path("CertificateAuthority/<int:pk>/edit/", views.CertificateAuthorityEditView.as_view(), name="certificateauthority_edit"),
    path("CertificateAuthority/import/", views.CertificateAuthorityBulkImportView.as_view(), name="certificateauthority_import"),
    path("CertificateAuthority/delete/", views.CertificateAuthorityBulkDeleteView.as_view(), name="certificateauthority_bulk_delete"),
    path("CertificateAuthority/<int:pk>/", views.CertificateAuthorityView.as_view(), name="certificateauthority"),
    path("CertificateAuthority/<int:pk>/delete/", views.CertificateAuthorityDeleteView.as_view(), name="certificateauthority_delete"),
    path("CertificateAuthority/<int:pk>/changelog/", ObjectChangeLogView.as_view(), name="certificateauthority_changelog", kwargs={"model": models.CertificateAuthority}),
    path("CertificateAuthority/<int:pk>/journal/", ObjectJournalView.as_view(), name="certificateauthority_journal", kwargs={"model": models.CertificateAuthority}),

)

src/netbox_cert_plugin/models.py
"""Models definitions"""

from django.db import models
from django.db.models import Q
from django.urls import reverse
from django.contrib.postgres.fields.array import ArrayField
from django.core.validators import MaxValueValidator, MinValueValidator
from netbox.models import NetBoxModel
from utilities.choices import ChoiceSet

class CaChoices(ChoiceSet):
    """CA choices definition class"""

    key = "Certificate.ca"

    DEFAULT_VALUE = "letsencrypt"

    CHOICES = [
        ("letsencrypt", "Let's Encrypt", "yellow"),
        ("commissign", "CommisSign", "red"),
        ("globalsign", "GlobalSign", "blue"),
        ("other", "Other", "black"),
    ]


class ExpirationTimeChoices(ChoiceSet):
    """Expiration time choices definition class"""

    key = "Certificate.expiration_time"

    DEFAULT_VALUE = "1m"

    CHOICES = [
        ("1m", "1 month", "blue"),
        ("3m", "3 months", "blue"),
        ("6m", "6 months", "blue"),
        ("1y", "1 year", "blue"),
        ("3y", "3 year", "blue"),
    ]

class ServiceChoices(ChoiceSet):
    """Service choices definition class"""

    key = "Certificate.service"

    CHOICES = [
        ("WIFI", "WIFI", "blue"),
        ("RPS", "RPS", "blue"),
        ("RAS", "RAS", "blue"),
        ("LB", "LB", "blue"),
    ]


class StateChoices(ChoiceSet):
    """CA choices definition class"""

    key = "Certificate.state"

    DEFAULT_VALUE = "to_be_created"

    CHOICES = [
        ("to_be_created", "To be created", "yellow"),
        ("creating", "Creating", "green"),
        ("errored", "Errored", "red"),
        ("valid", "Valid", "blue"),
        ("installed", "Installed", "green"),
        ("to_be_renewed", "To be renewed", "black"),
        ("renewing", "Renewing", "green"),
        ("to_be_revoked", "To be revoked", "orange"),
        ("revoked", "Revoked", "red")
    ]


class Certificate(NetBoxModel):
    """Certificate definition class"""

    cn = models.CharField(
        max_length=256,
        blank=False,
        verbose_name="Common Name",
        unique=True,
        help_text="Unique Common Name",
    )
    alt_name = ArrayField(
        base_field=models.CharField(max_length=256),
        null=True,
        blank=True,
        verbose_name="Alt Name",
        help_text="Alt Name is a list of host separated by commas (e.g. alt1,alt2,alt3)",
    )
    ca = models.CharField(
        max_length=32,
        choices=CaChoices,
        default=CaChoices.DEFAULT_VALUE,
        blank=False,
        verbose_name="Certificate Authority",
    )
    expiration_time = models.CharField(
        max_length=2,
        choices=ExpirationTimeChoices,
        default=ExpirationTimeChoices.DEFAULT_VALUE,
        blank=False,
        verbose_name="Expiration time needed",
    )
    cert_created_at = models.DateField(
        blank=True, null=True, verbose_name="Effective certificate's creation date"
    )
    cert_expired_at = models.DateField(
        blank=True, null=True, verbose_name="Effective certificate's expiration date"
    )
    state = models.CharField(
        max_length=32,
        default=StateChoices.DEFAULT_VALUE,
        blank=False,
        verbose_name="Certificate State",
    )
    content = models.TextField (
        max_length=32000,
        null=True,
        blank=True,
        verbose_name="PEM Certificate",
    )
    vault_url = models.URLField(
        max_length=256,
        null=True,
        blank=True,
        verbose_name="URL to corresponding vault",
    )
    service = models.CharField(
        max_length=32,
        choices=ServiceChoices,
        null=True,
        blank=True,
        verbose_name="Certificate Service",
    )

    class Meta:
        """Meta class"""

        ordering = ["cn"]

    def __str__(self):
        return str(self.cn)

    def get_absolute_url(self):
        """override"""
        return reverse("plugins:netbox_cert_plugin:certificate", args=[self.pk])

    # Netbox doesn't allow to show different value for the API and the GUI,
    # this code is changing the API value ex: "to_be_created" into "To be created" on the interface
    def get_state_display(self):
        """Return the display value for the state."""

        state_list = StateChoices()
        output = list(filter(lambda x:self.state in x, state_list))
        if len(output) > 0:
            output = output[0][1]
        else:
            return ""

        return output

class CertificateAuthority(NetBoxModel):
    """Certificate Authority definition class"""

    id = models.AutoField(primary_key=True)

    ca_name = models.CharField(
        max_length=64,
        blank=False,
        unique=True,
        verbose_name="CA Name"
    )
    acme_url = models.CharField(
        max_length=256,
        null=True,
        blank=True,
        verbose_name="ACME API URL"
    )
    key_vault_url = models.CharField(
        max_length=512,
        null=True,
        blank=True,
        verbose_name="ACME Vault URL"
    )
    start_date = models.DateField(
        blank=True, null=True, verbose_name="CA Valid From"
    )
    end_date = models.DateField(
        blank=True, null=True, verbose_name="CA Valid Until"
    )
    # Info : Unit in Days
    default_validity = models.IntegerField(
        blank=True, null=True,
        validators=[MinValueValidator(1), MaxValueValidator(2000)]
    )
    class Meta:
        """Meta class"""

        ordering = ["ca_name"]
        verbose_name_plural = "Certificate Authorities"
        constraints = [
            models.CheckConstraint(
                check=Q(end_date__gt=models.F('start_date')),
                name='The end date must be after the start date'
            ),
        ]

    def __str__(self):
        return str(self.ca_name)

    def get_absolute_url(self):
        """override"""
        return reverse("plugins:netbox_cert_plugin:certificateauthority", args=[self.pk])

src/netbox_cert_plugin/templates/netbox_cert_plugin/certificate.html
{% extends 'generic/object.html' %} {% block content %}
<div class="row mb-3">
  <div class="col col-md-6">
    <div class="card">
      <h5 class="card-header">CERTIFICATE</h5>
      <div class="card-body">
        <table class="table table-hover attr-table">
          <tr>
            <th scope="row">Common Name</th>
            <td>{{ object.cn }}</td>
          </tr>
          <tr>
            <th scope="row">Certificate Authority</th>
            <td>{{ object.get_ca_display }}</td>
          </tr>
          <tr>
            <th scope="row">Effective certificate's expiration date</th>
            <td>{{ object.cert_expired_at|placeholder }}</td>
          </tr>
        </table>
      </div>
    </div>
    {% include 'inc/panels/custom_fields.html' %}
    {% include 'inc/panels/tags.html' %}
  </div>
  <div class="col col-md-6">
    <div class="card">
      <h5 class="card-header">Details</h5>
      <div class="card-body">
        <table class="table table-hover attr-table">
          <tr>
            <th scope="row">Alt name</th>
            <td>{{ object.alt_name|placeholder }}</td>
          </tr>
          <tr>
            <th scope="row">Expiration time</th>
            <td>{{ object.get_expiration_time_display|placeholder }}</td>
          </tr>
          <tr>
            <th scope="row">State</th>
            <td>{{ object.get_state_display }}</td>
          </tr>
          <tr>
            <th scope="row">Effective certificate's creation date</th>
            <td>{{ object.cert_created_at|placeholder }}</td>
          </tr>
          <tr>
            <th scope="row">Certificate content</th>
            <td>
              <pre>{{ object.content|placeholder }}</pre>
            </td>
          </tr>
          <tr>
            <th scope="row">Vault URL</th>
            <td>{{ object.vault_url|placeholder }}</td>
          </tr>          
          <tr>
            <th scope="row">Service</th>
            <td>{{ object.service|placeholder }}</td>
          </tr>
        </table>
      </div>
    </div>
  </div>
</div>
{% endblock content %}

src/netbox_cert_plugin/templates/netbox_cert_plugin/certificateauthority.html
{% extends 'generic/object.html' %} {% block content %}
<div class="row mb-3">
  <div class="col col-md-6">
    <div class="card">
      <h5 class="card-header">Certificate Authority</h5>
      <div class="card-body">
        <table class="table table-hover attr-table">
          <tr>
            <th scope="row">CA Name</th>
            <td>{{ object.ca_name }}</td>
          </tr>
          <!-- <tr>
            <th scope="row">Certificate Authority</th>
            <td>{{ object.get_ca_display }}</td>
          </tr> -->
          <!-- <tr>
            <th scope="row">Effective certificate's expiration date</th>
            <td>{{ object.cert_expired_at|placeholder }}</td>
          </tr> -->
        </table>
      </div>
    </div>
    {% include 'inc/panels/custom_fields.html' %}
    {% include 'inc/panels/tags.html' %}
  </div>
  <div class="col col-md-6">
    <div class="card">
      <h5 class="card-header">Details</h5>
      <div class="card-body">
        <table class="table table-hover attr-table">
          <tr>
            <th scope="row">ACME API URL</th>
            <td>{{ object.acme_url|placeholder }}</td>
          </tr>
          <!-- <tr>
            <th scope="row">Expiration time</th>
            <td>{{ object.get_expiration_time_display|placeholder }}</td>
          </tr>
          <tr>
            <th scope="row">State</th>
            <td>{{ object.get_state_display|placeholder }}</td>
          </tr> -->
          <tr>
            <th scope="row">ACME Vault URL</th>
            <td>{{ object.key_vault_url|placeholder }}</td>
          </tr>
          <tr>
            <th scope="row">CA Valid From</th>
            <td>
              <pre>{{ object.start_date|placeholder }}</pre>
            </td>
          </tr>
          <tr>
            <th scope="row">CA Valid Until</th>
            <td>{{ object.end_date|placeholder }}</td>
          </tr>
          <tr>
            <th scope="row">Default Validity</th>
            <td>{{ object.default_validity|placeholder }}</td>
          </tr>
        </table>
      </div>
    </div>
  </div>
</div>
{% endblock content %}